﻿Imports Microsoft.Win32

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        If MainWindow.intFormat = 0 Then
            rbJpeg.Checked = True
        Else
            rbPng.Checked = True
        End If

        ' クリップボード読み出しディレイ
        Me.ComboBoxDelay.SelectedIndex = MainWindow.intDelay

        ' 簡易設定
        Me.txtFileNameBase.Text = MainWindow.strFileName

        Me.chkUseNumber.Checked = MainWindow.bAddNumber
        Me.txtNumber.Enabled = MainWindow.bAddNumber

        Me.chkDateTime.Checked = MainWindow.bAddDateTime
        Me.txtNumber.Text = MainWindow.intNumber.ToString()

        ' 詳細設定
        Me.txtFileNameFormat.Text = MainWindow.strFileName2
        Me.txtNumber2.Text = MainWindow.intNumber.ToString()

        ' 簡易指定か詳細指定か？
        If MainWindow.bolShosai = False Then
            TabControl1.SelectedIndex = 0
        Else
            TabControl1.SelectedIndex = 1
        End If

        ' 保存ダイアログは１つしか開かないようにする
        Me.chkSingle.Checked = MainWindow.bolSingle

    End Sub

    Private Sub btnOK_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click
        ' 設定をレジストリに保存してから、設定ダイアログを閉じる
        If TabControl1.SelectedIndex = 0 Then
            ' 簡易設定の場合
            If Me.txtFileNameBase.Text = "" Then
                MessageBox.Show("「出力先のフォルダ名＋ファイル名（拡張子を除く）の基礎部分」は、空にできません。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If

            Try
                Dim intTemp As Integer = Integer.Parse(Me.txtNumber.Text)
                If (intTemp < 0 OrElse intTemp > 99999999) Then
                    MessageBox.Show("連番の数値には0～99999999を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                Else
                    MainWindow.intNumber = intTemp
                End If
            Catch ex As System.FormatException
                MessageBox.Show("連番の数値には0～99999999を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("連番の数値には0～99999999を指定してください。", ex.ToString(), "設定")
                Return
            End Try

            Try
                ' フォルダの存在確認
                Dim strDirName As String = System.IO.Path.GetDirectoryName(Me.txtFileNameBase.Text)
                If Not System.IO.Directory.Exists(strDirName) Then
                    If DialogResult.Cancel = MessageBox.Show("フォルダ " + strDirName + " は存在しません。設定を続行してもよろしいですか?", "設定", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) Then
                        Return
                    End If
                End If
            Catch ex As System.ArgumentException
                MessageBox.Show("「出力先のフォルダ名＋ファイル名の基礎部分」にフォルダ名として指定できない文字が含まれています。入力内容を見直してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("「出力先のフォルダ名＋ファイル名の基礎部分」が不正です。", ex.ToString(), "設定")
                Return
            End Try
        Else
            ' 詳細設定の場合
            If Me.txtFileNameFormat.Text = "" Then
                MessageBox.Show("「出力先のフォルダ名＋ファイル名のフォーマット」は、空にできません。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If

            Try
                Dim intTemp As Integer = Integer.Parse(Me.txtNumber2.Text)
                If (intTemp < 0 OrElse intTemp > 99999999) Then
                    MessageBox.Show("連番の数値には0～99999999を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                Else
                    MainWindow.intNumber = intTemp
                End If
            Catch ex As System.FormatException
                MessageBox.Show("連番の数値には0～99999999を指定してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("連番の数値には0～99999999を指定してください。", ex.ToString(), "設定")
                Return
            End Try

            Try
                ' フォルダの存在確認
                Dim strDirName As String = System.IO.Path.GetDirectoryName(Me.txtFileNameBase.Text)
                If Not System.IO.Directory.Exists(strDirName) Then
                    ' フォルダの存在確認については、年月日や連番など不定なモノが入る可能性がアリ
                    ' とりあえずここでは存在を確認するフリだけ実施し、不正な文字を利用していた場合の
                    ' 例外の発生を誘う。
                End If
            Catch ex As System.ArgumentException
                MessageBox.Show("「出力先のフォルダ名＋ファイル名のフォーマット」にフォルダ名として指定できない文字が含まれています。入力内容を見直してください。", "設定", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            Catch ex As Exception
                ErrorDialog.ShowMessage("「出力先のフォルダ名＋ファイル名のフォーマット」が不正です。", ex.ToString(), "設定")
                Return
            End Try

        End If

        ' まずはいったん、ダイアログから設定値を読み出す
        If rbJpeg.Checked Then
            MainWindow.intFormat = 0 ' Jpeg
        Else
            MainWindow.intFormat = 1 ' Png
        End If

        ' 保存ダイアログは１つしか開かないようにする
        MainWindow.bolSingle = chkSingle.Checked

        ' クリップボード読み出しディレイ
        MainWindow.intDelay = ComboBoxDelay.SelectedIndex

        ' 簡易指定か詳細指定か
        If TabControl1.SelectedIndex = 1 Then
            MainWindow.bolShosai = True
        Else
            MainWindow.bolShosai = False
        End If

        ' [簡易指定の場合]
        MainWindow.strFileName = Me.txtFileNameBase.Text

        If chkDateTime.Checked Then
            MainWindow.bAddDateTime = True
        Else
            MainWindow.bAddDateTime = False
        End If

        If chkUseNumber.Checked Then
            MainWindow.bAddNumber = True
        Else
            MainWindow.bAddNumber = False
        End If

        ' [詳細指定の場合]
        MainWindow.strFileName2 = Me.txtFileNameFormat.Text

        Try
            ' レジストリキーのパスを指定してレジストリを開く
            Dim rKey As RegistryKey = Registry.CurrentUser.CreateSubKey(MainWindow.strRegName)
            If Not rKey Is Nothing Then
                ' レジストリの値を取得
                With rKey
                    ' 簡易指定か詳細指定か
                    If MainWindow.bolShosai = False Then
                        .SetValue("Shosai", 0)
                    Else
                        .SetValue("Shosai", 1)
                    End If

                    ' ファイル名のベース
                    .SetValue("FileNameBase", MainWindow.strFileName)

                    ' ファイル名のフォーマット
                    .SetValue("FileNameFormat", MainWindow.strFileName2)

                    ' 日付時刻を付与する
                    If MainWindow.bAddDateTime = False Then
                        .SetValue("AddDateTime", 0)
                    Else
                        .SetValue("AddDateTime", 1)
                    End If

                    ' 連番を付けるか
                    If MainWindow.bAddNumber = False Then
                        .SetValue("AddNumber", 0)
                    Else
                        .SetValue("AddNumber", 1)
                    End If

                    ' 保存形式
                    .SetValue("SaveFormat", MainWindow.intFormat)

                    ' 保存ダイアログは1つしか開かないようにする
                    If MainWindow.bolSingle = False Then
                        .SetValue("Single", 0)
                    Else
                        .SetValue("Single", 1)
                    End If

                    ' クリップボード読み出しディレイ
                    .SetValue("Delay", MainWindow.intDelay)

                    .Close()    ' 開いたレジストリキーを閉じる
                End With
            End If
        Catch ex As Exception
            ' レジストリへ書き込み失敗
            ErrorDialog.ShowMessage("レジストリへ設定値を書き込めません。", ex.ToString(), "設定")
        End Try

        Me.Visible = False

        If MainWindow.bFirstBoot Then
            MainWindow.bFirstBoot = False
        End If

        Me.Close()

    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        ' 設定をレジストリに保存しないで、設定ダイアログを閉じる
        Me.Close()

        'bFirstBootが設定されていたとしても、クリアせずにダイアログを閉じる。これにより、呼び出し元にキャンセルを伝える仕組み
        'If MainWindow.bFirstBoot Then
        'End If
    End Sub

    Private Sub btnBrowse_Click(sender As System.Object, e As System.EventArgs) Handles btnBrowse.Click
        FolderBrowserDialog1.SelectedPath = Me.txtFileNameBase.Text

        If FolderBrowserDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.txtFileNameBase.Text = FolderBrowserDialog1.SelectedPath

            ' 最後が \ で終わっていなかったら \ を付ける
            If Me.txtFileNameBase.Text.Length >= 1 Then
                If Me.txtFileNameBase.Text.Chars(Me.txtFileNameBase.Text.Length - 1) <> "\"c Then
                    Me.txtFileNameBase.Text += "\"
                End If
            End If

        End If
    End Sub

    Private Sub btnBrowse2_Click(sender As System.Object, e As System.EventArgs) Handles btnBrowse2.Click
        FolderBrowserDialog1.SelectedPath = Me.txtFileNameFormat.Text

        If FolderBrowserDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.txtFileNameFormat.Text = FolderBrowserDialog1.SelectedPath

            ' 最後が \ で終わっていなかったら \ を付ける
            If Me.txtFileNameFormat.Text.Length >= 1 Then
                If Me.txtFileNameFormat.Text.Chars(Me.txtFileNameFormat.Text.Length - 1) <> "\"c Then
                    Me.txtFileNameFormat.Text += "\"
                End If
            End If

        End If
    End Sub

    Private Sub chkUseNumber_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkUseNumber.CheckedChanged
        ' チェックボックスのON/OFFと番号入力欄の活性状態は連動する
        txtNumber.Enabled = chkUseNumber.Checked
    End Sub

    Private Sub Form1_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        ' 最初は必ず最前面に表示されるように
        Me.TopMost = True
        Me.Refresh()
        Me.TopMost = False
    End Sub

End Class
